Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## oracle.ifs.server
Class S_SystemObject

    java.lang.Object
      oracle.ifs.server.S_LibraryObject
          oracle.ifs.server.S_TieLibraryObject
              oracle.ifs.server.S_SystemObject

All Implemented Interfaces:
  IfsEventHandler, LibraryObjectInterface, SystemObjectInterface, Traceable

Direct Known Subclasses:
  S_TieSystemObject

    public class S_SystemObject

extends S_TieLibraryObject
implements SystemObjectInterface

The S_SystemObject class is the server side implementation of the iFS SYSTEMOBJECT class.

(Published)

Field Summary

Fields inherited from class oracle.ifs.server.S_LibraryObject
`CASCADE_OP_COPY_PUBLICOBJECT_TO_CATEGORY, CASCADE_OP_COPY_PUBLICOBJECT_TO_RIGHT_RELATIONSHIP, CASCADE_OP_DELETE_FAMILY_TO_VERSIONSERIES, CASCADE_OP_DELETE_PUBLICOBJECT_TO_LEFT_RELATIONSHIP, CASCADE_OP_DELETE_PUBLICOBJECT_TO_RIGHT_RELATIONSHIP, CASCADE_OP_DELETE_PUBLICOBJECT_TO_VERSIONDESCRIPTION, CASCADE_OP_DELETE_RELATIONSHIP_TO_LEFT_PUBLICOBJECT, CASCADE_OP_DELETE_RELATIONSHIP_TO_RIGHT_PUBLICOBJECT, CASCADE_OP_DELETE_VERSIONDESCRIPTION_TO_PUBLICOBJECT, CASCADE_OP_DELETE_VERSIONDESCRIPTION_TO_VERSIONSERIES, CASCADE_OP_DELETE_VERSIONSERIES_TO_FAMILY, CASCADE_OP_DELETE_VERSIONSERIES_TO_VERSIONDESCRIPTION, CASCADE_OP_FREE_CATEGORY_TO_PUBLICOBJECT, CASCADE_OP_FREE_CATEGORY_TO_SCHEMAOBJECT, CASCADE_OP_FREE_CATEGORY_TO_SYSTEMOBJECT, CASCADE_OP_FREE_FAMILY_TO_VERSIONSERIES, CASCADE_OP_FREE_PUBLICOBJECT_TO_CATEGORY, CASCADE_OP_FREE_PUBLICOBJECT_TO_LEFT_RELATIONSHIP, CASCADE_OP_FREE_PUBLICOBJECT_TO_RIGHT_RELATIONSHIP, CASCADE_OP_FREE_PUBLICOBJECT_TO_VERSIONDESCRIPTION, CASCADE_OP_FREE_RELATIONSHIP_TO_LEFT_PUBLICOBJECT, CASCADE_OP_FREE_RELATIONSHIP_TO_RIGHT_PUBLICOBJECT, CASCADE_OP_FREE_SCHEMAOBJECT_TO_CATEGORY, CASCADE_OP_FREE_SYSTEMOBJECT_TO_CATEGORY, CASCADE_OP_FREE_VERSIONDESCRIPTION_TO_PUBLICOBJECT, CASCADE_OP_FREE_VERSIONDESCRIPTION_TO_VERSIONSERIES, CASCADE_OP_FREE_VERSIONSERIES_TO_FAMILY, CASCADE_OP_FREE_VERSIONSERIES_TO_VERSIONDESCRIPTION, CASCADE_OP_UNDEFINED, CASCADE_OP_UNDELETE_FAMILY_TO_VERSIONSERIES, CASCADE_OP_UNDELETE_PUBLICOBJECT_TO_LEFT_RELATIONSHIP, CASCADE_OP_UNDELETE_PUBLICOBJECT_TO_RIGHT_RELATIONSHIP, CASCADE_OP_UNDELETE_PUBLICOBJECT_TO_VERSIONDESCRIPTION, CASCADE_OP_UNDELETE_RELATIONSHIP_TO_LEFT_PUBLICOBJECT, CASCADE_OP_UNDELETE_RELATIONSHIP_TO_RIGHT_PUBLICOBJECT, CASCADE_OP_UNDELETE_VERSIONDESCRIPTION_TO_PUBLICOBJECT, CASCADE_OP_UNDELETE_VERSIONDESCRIPTION_TO_VERSIONSERIES, CASCADE_OP_UNDELETE_VERSIONSERIES_TO_FAMILY, CASCADE_OP_UNDELETE_VERSIONSERIES_TO_VERSIONDESCRIPTION, CASCADE_OP_UPDATE_CATEGORY_TO_PUBLICOBJECT, CASCADE_OP_UPDATE_CATEGORY_TO_SCHEMAOBJECT, CASCADE_OP_UPDATE_CATEGORY_TO_SYSTEMOBJECT, CASCADE_OP_UPDATE_PUBLICOBJECT_TO_CATEGORY, CASCADE_OP_UPDATE_SCHEMAOBJECT_TO_CATEGORY, CASCADE_OP_UPDATE_SYSTEMOBJECT_TO_CATEGORY, DEFAULT_RENDERER, m_ClassId, m_Id, m_Session`

Constructor Summary
`protected` | `S_SystemObject(S_LibrarySession session, java.lang.Long classId)` Construct a S_SystemObject object.
`protected` | `S_SystemObject(S_LibrarySession session, S_LibraryObjectData data)` Construct a S_SystemObject object.

Method Summary
`protected S_SystemCategory` | `addCategory(SystemCategoryDefinition catdef)` Add a SystemCategory to the target object.
`protected void` | `cascadeFree(OperationState opState, S_LibraryObjectDefinition def)` cascade operations to be performed before freeing an object.
`protected void` | `createCategories(S_LibraryObjectDefinition sdef)` Create a set of categories.
`protected void` | `deriveDefinition(S_LibraryObjectDefinition sdef)` Add to the S_LibraryObjectDefinition for this class.
`protected void` | `extendedPostInsert(OperationState opState, S_LibraryObjectDefinition sdef)` Operations to be performed after creating an object.
`protected void` | `extendedPostUpdate(OperationState opState, S_LibraryObjectDefinition sdef)` Extended operations to be performed after updating an object.
`protected void` | `extendedPreInsert(OperationState opState, S_LibraryObjectDefinition sdef)` Performs pre-insert actions.
`protected void` | `extendedPreUpdate(OperationState opState, S_LibraryObjectDefinition sdef)` Update any system attributes appropriate for creating this object
`S_SystemCategory[]` | `getCategories()` Get all system categories associated with this instance.
`S_SystemCategory[]` | `getCategories(S_ClassObject classobj)` Returns the associated SystemCategory objects that are instances of the ClassObject (or one of its subclasses) specified.
`S_SystemCategory[]` | `getCategories(SortSpecification sort)` Get all Systemcategories associated with this instance.
`protected void` | `handleCascade(OperationState opState, S_LibraryObject source, int cascadeType, S_LibraryObjectDefinition sdef, java.lang.Object customArg)` handle a cascaded operation initiated by (usually) another object.
`protected void` | `removeCategories(S_LibraryObjectDefinition sdef)` Remove a set of categories.
`protected void` | `updateCategories(S_LibraryObjectDefinition sdef)` Update a set of categories.
`protected void` | `verifyCanCreate(S_LibraryObjectDefinition def)` Verifies that the instance can be created.
`protected void` | `verifyCanFree()` Verifies that the instance can be freed.
`protected void` | `verifyCanUpdate()` Verifies that the instance can be updated.

Methods inherited from class oracle.ifs.server.S_LibraryObject
`applyValueDefault, associatedPostFree, associatedPostInsert, associatedPreInsert, cascadeCopy, cascadeUpdate, checkRequiredForInsert, checkSettable, clearArrayTypeAttributeValues, clonePublicObjectAttribute, constructIdArray, constructIdArray, copy, copy, copyVectorToLibraryObjectArray, createDefaultPolicyPropertyBundle, createDefaultPropertyBundle, createInstance, deleteRows, deriveOwnerUniqueName, deriveOwnerUniqueName, deriveUppercasedAttribute, determineClassDomain, determinePolicy, determinePolicy, determineValueDefault, determineValueDomain, dispose, DYNLockRows, equals, executePolicyOperation, extendedPostFree, extendedPreCopy, extendedPreFree, findPolicyFromPropertyBundleAv, free, free, getAttribute, getAttributeByUpperCaseName, getAuditCertificateName, getAuditDomainContext, getAuditEventFolderContext, getClassData, getClassId, getClassName, getClassObject, getData, getDefinition, getEffectivePolicyActionContexts, getEffectivePolicyListElements, getEventualAttributeByUpperCaseName, getId, getLibraryConnection, getName, getObjectReferenceAttribute, getPropertyBundle, getPropertyValue, getResourceString, getResourceString, getService, getSession, getSessionInterface, getTraceLogger, handleEvent, hashCode, hasNameAttribute, insertReferenceAttributes, insertRow, insertRows, invalidateState, invokeOperation, invokePolicyMethod, isAuditCertificateSecured, isBroadcastCreateEventEnabled, isInstanceOf, issueCascade, isTraced, lockRows, postEvent, postEvent, postFree, postInsert, postUpdate, preFree, preInsert, preUpdate, renderAsReader, renderAsStream, setAttribute, setAttribute, setAttributes, toString, trace, update, updateRows, verifyCanGetContent, verifyCanSetContent, verifyCanSetPolicy, verifyWriteableTransactionInProgress`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface oracle.ifs.common.LibraryObjectInterface
`getAttributeByUpperCaseName, getClassId, getId, getSessionInterface`

Methods inherited from interface oracle.ifs.common.Traceable
`getTraceLogger, isTraced, trace`

Constructor Detail

### S_SystemObject

    protected S_SystemObject(S_LibrarySession session,
                             S_LibraryObjectData data)
                      throws IfsException

  Construct a S_SystemObject object. This is the standard variant.

  Parameters:
    `session` - current LibrarySession
    `data` - Data component
  Throws:
    `IfsException`
  (Unpublished)

### S_SystemObject

    protected S_SystemObject(S_LibrarySession session,
                             java.lang.Long classId)
                      throws IfsException

  Construct a S_SystemObject object. This variant is used for objects taht have not been created in the database yet.

  Parameters:
    `session` - current LibrarySession
  Throws:
    `IfsException`
  (Unpublished)

Method Detail

### deriveDefinition

    protected void deriveDefinition(S_LibraryObjectDefinition sdef)
                             throws IfsException

  Description copied from class: `S_SystemObject`
  Add to the S_LibraryObjectDefinition for this class. This is called by getDefinition() on S_LibraryObject. This must call super.deriveDefinition() before applying any class-specific changes to the S_LibraryObjectDefinition object.

  Overrides:
    `deriveDefinition` in class `S_LibraryObject`
  Parameters:
    `sdef` - the S_LibraryObjectDefinition that contains the definition of the target object.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### verifyCanCreate

    protected void verifyCanCreate(S_LibraryObjectDefinition def)
                            throws IfsException

  Description copied from class: `S_SystemObject`
  Verifies that the instance can be created. This is called as part of the createInstance sequence; therefore, we return without throwing here, as the newSystemObject() method would have thrown if user wasn't admin mode; so if we get this far, the SystemObject creation is done through a PublicObject method (e.g. addProperty to PropertyBundle). An explicit override is included here mostly for documentation, as our superclass does the same thing.

  Overrides:
    `verifyCanCreate` in class `S_LibraryObject`
  Parameters:
    `def` - the definition
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### verifyCanFree

    protected void verifyCanFree()
                          throws IfsException

  Description copied from class: `S_SystemObject`
  Verifies that the instance can be freed. This is called as part of the free() sequence; therefore, we return without throwing here, as the DMFree() method would have thrown if user wasn't in admin mode; so if we get this far, the SystemObject free is done through a PublicObject method (e.g. removeProperty from PropertyBundle). An explicit override is included here mostly for documentation, as our superclass does the same thing.

  Overrides:
    `verifyCanFree` in class `S_LibraryObject`
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### verifyCanUpdate

    protected void verifyCanUpdate()
                            throws IfsException

  Description copied from class: `S_SystemObject`
  Verifies that the instance can be updated. This is called as part of the update() sequence; therefore, we return without throwing here, as the DMSetAttributes() method would have thrown if user wasn't in admin mode; so if we get this far, the SystemObject free is done through a PublicObject method (e.g. resequencing relationships). An explicit override is included here mostly for documentation, as our superclass does the same thing.

  Overrides:
    `verifyCanUpdate` in class `S_LibraryObject`
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### extendedPreInsert

    protected void extendedPreInsert(OperationState opState,
                                     S_LibraryObjectDefinition sdef)
                              throws IfsException

  Description copied from class: `S_SystemObject`
  Performs pre-insert actions.

  Overrides:
    `extendedPreInsert` in class `S_LibraryObject`
  Parameters:
    `opState` - current operation state
    `sdef` - the definition for the insert operation
  Throws:
    `IfsException` - if the operation fails
  (Published)

### extendedPostInsert

    protected void extendedPostInsert(OperationState opState,
                                      S_LibraryObjectDefinition sdef)
                               throws IfsException

  Description copied from class: `S_SystemObject`
  Operations to be performed after creating an object.

  This is overridden by classes that need to perform operations after successfully creating the rows for the new instance.

  Overrides:
    `extendedPostInsert` in class `S_LibraryObject`
  Parameters:
    `opState` - current operation state
    `sdef` - object definition
  Throws:
    `IfsException` - if operation fails.
  (Published)

### extendedPreUpdate

    protected void extendedPreUpdate(OperationState opState,
                                     S_LibraryObjectDefinition sdef)
                              throws IfsException

  Description copied from class: `S_SystemObject`
  Update any system attributes appropriate for creating this object

  Overrides:
    `extendedPreUpdate` in class `S_LibraryObject`
  Parameters:
    `opState` - the operation state
    `sdef` - current object definition to be updated with system attributes
  Throws:
    `IfsException` - if operation fails.
  (Published)

### extendedPostUpdate

    protected void extendedPostUpdate(OperationState opState,
                                      S_LibraryObjectDefinition sdef)
                               throws IfsException

  Description copied from class: `S_SystemObject`
  Extended operations to be performed after updating an object.

  This is overridden by classes that need to perform operations after updating this object in the database, but before commit.

  Overrides:
    `extendedPostUpdate` in class `S_LibraryObject`
  Parameters:
    `opState` - the Operation state
    `sdef` - the S_LibraryObjectDefinition that contains the updates.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### handleCascade

    protected void handleCascade(OperationState opState,
                                 S_LibraryObject source,
                                 int cascadeType,
                                 S_LibraryObjectDefinition sdef,
                                 java.lang.Object customArg)
                          throws IfsException

  Description copied from class: `S_SystemObject`
  handle a cascaded operation initiated by (usually) another object. This is overridden by classes to add custom handlers. It is ok if no class handles the cascade (that is implied to mean "no action needed").

  Overrides:
    `handleCascade` in class `S_LibraryObject`
  Parameters:
    `opState` - originating operation state
    `source` - object initiating this cascade request (not necessarily the original object)
    `cascadeType` - type of cascade request
    `sdef` - original Definition object
    `customArg` - any custom parameter.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### cascadeFree

    protected void cascadeFree(OperationState opState,
                               S_LibraryObjectDefinition def)
                        throws IfsException

  Description copied from class: `S_SystemObject`
  cascade operations to be performed before freeing an object. This is overridden by classes that need to perform operations before successfully freeing the rows for the freed instance.

  Overrides:
    `cascadeFree` in class `S_LibraryObject`
  Parameters:
    `opState` - originating operation state
    `def` - original Definition object
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### addCategory

    protected S_SystemCategory addCategory(SystemCategoryDefinition catdef)
                                    throws IfsException

  Description copied from class: `S_SystemObject`
  Add a SystemCategory to the target object.

  Parameters:
    `catdef` - the SystemCategoryDefinition object that describes the system category to create
  Returns:
    the newly created SystemCategory
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### createCategories

    protected void createCategories(S_LibraryObjectDefinition sdef)
                             throws IfsException

  Description copied from class: `S_SystemObject`
  Create a set of categories.

  Called as part `extendedPostInsert` and `extendedPostUpdate` to create categories. Only creates them if indicated by the CreateCategoriesServerSideOption on the definition.

  Throws:
    `IfsException`
  (Unpublished)

### updateCategories

    protected void updateCategories(S_LibraryObjectDefinition sdef)
                             throws IfsException

  Description copied from class: `S_SystemObject`
  Update a set of categories. This can be called during the update of a systemobject

  Throws:
    `IfsException`
  (Unpublished)

### removeCategories

    protected void removeCategories(S_LibraryObjectDefinition sdef)
                             throws IfsException

  Description copied from class: `S_SystemObject`
  Remove a set of categories. This can be called during the update of of the SystemObject.

  Throws:
    `IfsException`
  (Unpublished)

### getCategories

    public S_SystemCategory[] getCategories()
                                     throws IfsException

  Description copied from class: `S_SystemObject`
  Get all system categories associated with this instance.

  Returns:
    the array of system category objects.
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getCategories

    public S_SystemCategory[] getCategories(S_ClassObject classobj)
                                     throws IfsException

  Description copied from class: `S_SystemObject`
  Returns the associated SystemCategory objects that are instances of the ClassObject (or one of its subclasses) specified. Returns null if no SystemCategory objects are associated.

  Parameters:
    `classobj` - the class of SystemCategory
  Returns:
    array of SystemCategory objects associated with the target object.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getCategories

    public S_SystemCategory[] getCategories(SortSpecification sort)
                                     throws IfsException

  Description copied from class: `S_SystemObject`
  Get all Systemcategories associated with this instance.

  Returns:
    the array of Systemcategory objects.
  Throws:
    `IfsException` - if the operation fails
  (Published)

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD